
proc soundctrl_init { obj eve userdata } {
global vsTclScript vsPeriodicTask soundctrl_mode0 soundctrl_mode1 soundctrl_mode2
global soundlength vsObjAttrName

set soundlength(bb,0) 4002
set soundlength(bb,1) 3504
set soundlength(bb,2) 3208
set soundlength(pony,0) 3860
set soundlength(pony,1) 3502
set soundlength(pony,2) 3100
set soundlength(saru,0) 4795
set soundlength(saru,1) 4299
set soundlength(saru,2) 3800

        set soundctrl_mode0 0
        set soundctrl_mode1 0
        set soundctrl_mode2 0

        vsPlayAmbientSoundByName c4 1
        vsSuspendSoundByName c4
        vsPlayAmbientSoundByName c3 1
        vsSuspendSoundByName c3
        vsPlayAmbientSoundByName c2 1
        vsSuspendSoundByName c2
        vsPlayAmbientSoundByName c1 1
        vsSuspendSoundByName c1
        vsPlayAmbientSoundByName b4 1
        vsSuspendSoundByName b4
        vsPlayAmbientSoundByName b3 1
        vsSuspendSoundByName b3
        vsPlayAmbientSoundByName b2 1
        vsSuspendSoundByName b2
        vsPlayAmbientSoundByName b1 1
        vsSuspendSoundByName b1
        vsPlayAmbientSoundByName a4 1
        vsSuspendSoundByName a4
        vsPlayAmbientSoundByName a3 1
        vsSuspendSoundByName a3
        vsPlayAmbientSoundByName a2 1
        vsSuspendSoundByName a2
        vsPlayAmbientSoundByName a1 1

	set me [vsGetPerson]
	vsNewVariable $me nowsound a1

	vsGetObjAttribute $obj $vsObjAttrName objname
	set round [vsGetVariable $me round]
        vsAddTimeOutHandler $obj $soundlength($objname,0) $vsTclScript "" "soundctrl_play" 0 $vsPeriodicTask
        vsAddTimeOutHandler $obj $soundlength($objname,1) $vsTclScript "" "soundctrl_play" 1 $vsPeriodicTask
        vsAddTimeOutHandler $obj $soundlength($objname,2) $vsTclScript "" "soundctrl_play" 2 $vsPeriodicTask
}

proc soundctrl_play { obj eve userdata } {
global vsContinue soundctrl_mode1 soundctrl_mode2 soundctrl_mode0

	set me [vsGetPerson]
	set round [vsGetVariable $me round]
	set sname [vsGetVariable $me nowsound]
   if { $userdata == 0 && $round == 0 } {
#vsWarning "suspend $sname"

	set mode [expr $soundctrl_mode0 %4 + 1 ]

        if {  $mode == 1 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  a2
		vsSetVariable $me nowsound a2
        } elseif {  $mode == 2 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  a3
		vsSetVariable $me nowsound a3
        } elseif {  $mode == 3 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  a4
		vsSetVariable $me nowsound a4
        } elseif {  $mode == 4 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  a1
		vsSetVariable $me nowsound a1
        }

    incr soundctrl_mode0

    } elseif { $userdata == 1 && $round == 1 } {
#vsWarning "suspend $sname"

	set mode [expr $soundctrl_mode1 %4 + 1 ]

        if {  $mode == 1 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  b2
		vsSetVariable $me nowsound b2
        } elseif {  $mode == 2 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  b3
		vsSetVariable $me nowsound b3
        } elseif {  $mode == 3 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  b4
		vsSetVariable $me nowsound b4
        } elseif {  $mode == 4 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  b1
		vsSetVariable $me nowsound b1
        }
    incr soundctrl_mode1

    } elseif { $userdata ==  2 && $round == 2} {
#vsWarning "suspend $sname"

	set mode [expr $soundctrl_mode2 %4 + 1 ]

        if {  $mode == 1 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  c2
		vsSetVariable $me nowsound c2
        } elseif {  $mode == 2 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  c3
		vsSetVariable $me nowsound c3
        } elseif {  $mode == 3 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  c4
		vsSetVariable $me nowsound c4
        } elseif {  $mode == 4 } {
                vsSuspendSoundByName  $sname
                vsResumeSoundByName  c1
		vsSetVariable $me nowsound c1
        }
    incr soundctrl_mode2
    }

    return $vsContinue
}                             
