if {"" == [info globals __kinema_tcl__]} {
set __kiname_tcl__ 0

proc KinMove { obj ev userdata } {
global cur max
global newname_KinCounter newname_slow vsContinue vsStop 

    set mainobj $userdata
    set speed [vsGetVariable $mainobj speed]
    set skip [vsGetVariable $mainobj skip]
    set step [vsGetVariable $mainobj step]
    set mode [vsGetVariable $mainobj mode]

    incr newname_KinCounter
    vsKinGetFrame $obj cur max

    if { $mode == 1 } {
	if { $speed == $newname_KinCounter } {
		vsKinSetFrame $obj [expr ($cur + $step * $skip + 10 * $max) % $max] 
		set newname_KinCounter 0
    	}
    } else {
	vsKinNextPosture $obj
    }
	

    set return_value [alyConfigKinMove newname $obj $cur $max]
    return $return_value
}

proc KinInit { obj eve userdata } {
    
    global vsTclScript vsPeriodicTask newname_KinCounter 

	source [vsWwwGetFile ../intro/kinconf.tcl]

    alyConfigKinInit $obj $eve $userdata

    set millisecond $userdata
    set newname 0
    vsKinNew newname.wrl newname
    set newname_KinCounter 0
    vsNewVariable $obj speed 1
    vsNewVariable $obj skip 1
    vsNewVariable $obj step 1
    vsNewVariable $obj id $newname
    vsNewVariable $obj mode 2
    vsAddTimeOutHandler $newname $millisecond $vsTclScript "" newname_KinMove $obj $vsPeriodicTask
}
}
