# tate-gata remocon by yuji
vstkInit

proc ctrl_init { obj eve userdata } {
global cur max
global vsContinue
	
	set w .ctrl
	toplevel $w
	wm title $w "Kinemation Controller v1.1"
	wm iconname $w "Kinemation Controller v1.1"

$w config -bg #444
frame $w.b  -bg #444  -highlightbackground #444
frame $w.main  -bg #444  -highlightbackground #444
frame $w.rewind  -bg #444  -highlightbackground #444
	radiobutton $w.play -command "playKin $obj" -variable m -value 1\
		-bitmap @[vsWwwGetFile ../lib/kinctrl/play.xbm]  -bg gray10 -fg #2B0 \
		-selectcolor #000 \
		-highlightbackground #444 \
		-indicatoron 0;
	radiobutton $w.back -command "backKin $obj" -variable m -value 2\
		-bitmap @[vsWwwGetFile ../lib/kinctrl/back.xbm] -bg gray10 -fg #2B0 \
		-selectcolor #000 \
		-highlightbackground #444 \
		-indicatoron 0;
	radiobutton $w.stop -command "stopKin $obj" -variable m -value 3\
		-bitmap @[vsWwwGetFile ../lib/kinctrl/stop.xbm] -bg gray10 -fg #2B0 \
		-selectcolor #000 \
		-highlightbackground #444 \
		-indicatoron 0;

	radiobutton $w.last -command "fwdKin $obj" -variable m -value 4\
		-bitmap @[vsWwwGetFile ../lib/kinctrl/last.xbm] -bg gray10 -fg #2B0 \
		-selectcolor #000 \
		-highlightbackground #444 \
		-indicatoron 0;
	radiobutton $w.first -command "rewKin $obj" -variable m -value 5\
		-bitmap @[vsWwwGetFile ../lib/kinctrl/first.xbm] -bg gray10 -fg #2B0 \
		-selectcolor #000 \
		-highlightbackground #444 \
		-indicatoron 0;
pack $w.first $w.last -side left -in $w.rewind -fill both -expand 1
pack $w.back $w.stop $w.play -side left -in $w.main -fill x -pady 10 -expand 1


#date
	button $w.time  -command { set a [vsGetCTime] ; vsWarning $a} \
		-highlightbackground #000 \
		-text "time" -bg gray10 -fg #2B0 ;

	set kinobj [vsGetVariable $obj id] 
	vsKinGetFrame $kinobj cur max
scale $w.scale -from 0 -to [expr $max-1] -orient horizontal -variable cur \
	-command "vsKinSetFrame $kinobj" \
	-relief sunken -bg #898 -fg #444 -showvalue 0  -troughcolor #898 \
	-sliderrelief ridge

frame $w.mode -bg #444
	radiobutton $w.mode1 -relief sunken -command "vsSetVariable $obj mode 1" -text 1 -variable mode -value 1\
		-bg gray10 -fg #2B0 -selectcolor #000 \
		-highlightbackground #444
	radiobutton $w.mode2 -relief sunken -command "vsSetVariable $obj mode 2" -text 2 -variable mode -value 2\
		-bg gray10 -fg #2B0 -selectcolor #000 \
		-highlightbackground #444
pack $w.mode1 $w.mode2 -side left -expand 1 -fill x -in $w.mode 


	label $w.counter -width 5 -textvariable cur -relief sunken \
		-bg #898 -fg #444 -anchor e\
		-font -*-*-bold-*-*-*-16-*-*-*-m-*-*-*- 
	set max 0
	set cur 0

frame $w.trim -relief sunken  -bg #444  -highlightbackground #000
frame $w.speed -bg #444
	button $w.fast -text "+" -command "speedUpKin $obj" \
		-highlightbackground #444 \
	-font -*-*-bold-*-*-*-10-*-*-*-m-*-*-*-  -bg gray10 -fg #2B0 ;
	button $w.slow -text "-" -command "speedDownKin $obj" \
		-highlightbackground #444 \
	-font -*-*-bold-*-*-*-10-*-*-*-m-*-*-*-  -bg gray10 -fg #2B0 ;
label $w.speed.label -text speed \
	-font -*-*-*-*-*-*-10-*-*-*-m-*-*-*-  -bg #444 -fg #2B0 ;
pack $w.fast $w.speed.label $w.slow -side top -in $w.speed 

frame $w.prec -bg #444
button $w.con -command "HighKin $obj" \
	-font -*-*-bold-*-*-*-10-*-*-*-m-*-*-*- \
		-highlightbackground #444 \
	-bitmap @[vsWwwGetFile ../lib/kinctrl/con2.xbm] -bg gray10 -fg #2B0 ;
button $w.ex -command "LowKin $obj" \
	-font -*-*-bold-*-*-*-10-*-*-*-m-*-*-*- \
		-highlightbackground #444 \
	-bitmap @[vsWwwGetFile ../lib/kinctrl/ex2.xbm] -bg gray10 -fg #2B0 ;
label $w.prec.label -text prec \
	-font -*-*-*-*-*-*-10-*-*-*-m-*-*-*-  -bg #444 -fg #2B0 ;
pack $w.con $w.prec.label $w.ex -side top -in $w.prec
pack $w.speed $w.prec -side left -in $w.trim -expand 1 -padx 5 -pady 5 

pack $w.trim $w.main $w.rewind $w.scale $w.counter -side bottom -in $w.b -fill x 
#pack $w.vol -side left -expand 1 -fill both  -in $w.b
pack $w.mode $w.b -side bottom -expand 1 -fill both  

catch {image delete image1a}
#image create photo image1a -file [vsWwwGetFile "../lib/kinctrl/remo2.gif"] -format gif
#image create photo image1a -file $tk_library/demos/images/earth.gif
#label $w.image -image image1a
label $w.image -bg #444  -highlightbackground #444
pack $w.b $w.image -side top -fill x
}

proc rewKin { obj } {
	global cur
	global vsContinue
	stopKin $obj
	set kinobj [vsGetVariable $obj id] 
	vsKinSetFrame $kinobj 0
	return $vsContinue
}
proc fwdKin { obj } {
	global max cur
	global vsContinue
	stopKin $obj
	set kinobj [vsGetVariable $obj id] 
	vsKinSetFrame $kinobj [expr $max-1]
	return $vsContinue
}
proc stopKin { obj } {
	vsSetVariable $obj step 0	
}
proc backKin { obj } {
	vsSetVariable $obj step -1	
}
proc playKin { obj } {
	vsSetVariable $obj step 1	
}

proc LowKin { obj } {
	set skip [vsGetVariable $obj skip]
	vsSetVariable $obj skip [expr $skip+1]
}
proc HighKin { obj } {
	set skip [vsGetVariable $obj skip]
	if { $skip > 1} {
	vsSetVariable $obj skip [expr $skip-1]
	} 
}

proc speedUpKin { obj } {
	set s  [vsGetVariable $obj speed]
	vsSetVariable $obj speed [expr $s-1]
	if { $s < 2} { vsSetVariable $obj speed 1 } 
}
proc speedDownKin { obj } {
	set speed [vsGetVariable $obj speed]
	vsSetVariable $obj speed [expr $speed+1]
}
