proc cocpit_init { obj eve userdata } {
global wall vsPick vsDrag vsGrab vsRelease vsTclScript 
global cocpit_xx cocpit_yy cocpit_lastx cocpit_lasty cocpit_cx cocpit_cy
#global cocpit_count cocpit_skip
global cocpit_lock
	set me [vsGetPerson]
	set wall [vsAddObjFromFile $me [vsWwwGetFile ../lib/cocpit/wall.wrl]]


	set cocpit_lock 0
	set cocpit_skip 10
	set cocpit_count 0
	set cocpit_xx 0
	set cocpit_yy 0
	set cocpit_lastx 0
	set cocpit_lasty 0
	vsNewVariable $me velocx $cocpit_xx
	vsNewVariable $me velocy $cocpit_yy

	set Mouse [expr $vsPick|$vsDrag]
	vsAddEventHandler $wall $vsRelease $vsTclScript "" cocpit_released $userdata
	vsAddEventHandler $wall $vsDrag $vsTclScript "" cocpit_draged $userdata
	vsAddEventHandler $wall $vsGrab $vsTclScript "" cocpit_grabed $userdata
	vsAddEventHandler $wall $vsPick $vsTclScript "" cocpit_picked $userdata

	set me [vsGetPerson]
	vsNewVariable $me hid -1

}

proc cocpit_picked { obj eve userdata } {
global wall vsPick vsDrag vsGrab vsRelease vsTclScript vsCSWorld vsAbsolute
global vsSporadicTask
global vsPeriodicTask
global cocpit_rot

	set me [vsGetPerson]
	vsSetVariable $me first 0
	set mat [vsGetVariable $me mat]	

	set e "vsRotateTranslate $me $mat $vsCSWorld $vsAbsolute"
	eval $e
	set cocpit_rot 0
	vsAddTimeOutHandler $obj 70 $vsTclScript "" "cocpit_undo" "data" $vsPeriodicTask
}

proc cocpit_undo { obj eve userdata } {
global cocpit_rot vsStop vsContinue vsCSWorld vsRelative

	if { $cocpit_rot == 40  } {
		set me [vsGetPerson]
		vsSetVariable $me first -1
		return $vsStop
	} else {
		set me [vsGetPerson]
		vsRotateAngle $me 0 1 0 $vsCSWorld $vsRelative
		incr cocpit_rot
		return $vsContinue
	}
	
}

proc cocpit_released { obj eve userdata } {
global cocpit_lastx cocpit_lasty cocpit_xx cocpit_yy 
global cocpit_count cocpit_skip
global cocpit_lock

	set cocpit_xx 0
	set cocpit_yy 0

	set me [vsGetPerson]
	vsSetVariable $me velocx $cocpit_xx
	vsSetVariable $me velocy $cocpit_yy

	set hid [vsGetVariable $me hid]
	if { $hid != -1 } {
	vsRemoveTimeOutHandler $me $hid
	}
	set cocpit_count 0
	set cocpit_lock 0
}


proc cocpit_draged { obj eve userdata } {
global cocpit_lastx cocpit_lasty cocpit_xx cocpit_yy cocpit_cx cocpit_cy
global cocpit_skip cocpit_count

	incr cocpit_count
	if { $cocpit_xx != 0 } {
	if { [expr $cocpit_count % $cocpit_skip] == 0} {	
		cocpit_dragselect $eve
	}
	} else {
		cocpit_dragselect $eve
	}

}

proc cocpit_dragselect { eve } {
global cocpit_lastx cocpit_lasty cocpit_xx cocpit_yy cocpit_cx cocpit_cy
global cocpit_skip cocpit_count
global vsCSLocal vsRelative
global vsPeriodicTask vsTclScript


	vsGetEvent2DPoint $eve cocpit_cx cocpit_cy
	set cocpit_xx [expr $cocpit_cx-$cocpit_lastx]
	set cocpit_yy [expr $cocpit_cy-$cocpit_lasty]

	set me [vsGetPerson]
	vsSetVariable $me velocx $cocpit_xx
	vsSetVariable $me velocy $cocpit_yy

	set hid [vsGetVariable $me hid]
	if { $hid != -1 } {
		vsRemoveTimeOutHandler $me $hid
	}
	set vx [expr $cocpit_xx/100.0]
	set vz [expr $cocpit_yy/100.0]
	set data "${vx}:${vz}"
	set hid [vsAddTimeOutHandler $me 20 $vsTclScript "" "cocpit_move" $data $vsPeriodicTask]
	vsSetVariable $me hid $hid

	set cocpit_lastx $cocpit_cx
	set cocpit_lasty $cocpit_cy

}

proc cocpit_move { obj eve userdata } {
global vsContinue vsCSLocal vsRelative
global cocpit_lock

	set v [split $userdata : ]
	set vx [lindex $v 0]
	set vz [lindex $v 1]

	vsTranslate $obj 0 0 $vz $vsCSLocal $vsRelative
	#vsTranslate $obj $vx 0 $vz $vsCSLocal $vsRelative
	if { $cocpit_lock == 0 } {
	set me [vsGetPerson]
	set speed [vsGetVariable $me speed]
	if { $speed >= -4 && $speed <= 4 } {
	if { $vz > 0 } {
		vsSetVariable $me speed [expr $speed+1 ]
	} else {
		vsSetVariable $me speed [expr $speed-1 ]
	}
	}
	set cocpit_lock 1
	}
	
	return $vsContinue
}

proc cocpit_grabed { obj eve userdata } {
global cocpit_lastx cocpit_lasty cocpit_xx cocpit_yy cocpit_cx cocpit_cy
global  cocpit_skip cocpit_count

	
	vsGetEvent2DPoint $eve cocpit_cx cocpit_cy
	
	set cocpit_lastx $cocpit_cx
	set cocpit_lasty $cocpit_cy
	set cocpit_xx 0
	set cocpit_yy 0

	set me [vsGetPerson]
	vsSetVariable $me velocx $cocpit_lastx
	vsSetVariable $me velocy $cocpit_lasty

	set cocpit_skip 10
	set cocpit_count 0
}
