
proc libkinInit { obj eve userdata } {

	source [vsWwwGetFile "../lib/kinctrl/kinema.tcl"]

 	split_args USERDATA $userdata 

	set args1 [info args KinInit ]
	set args2 [info args KinMove ]
	set body1 [info body KinInit ]
	set body2 [info body KinMove ]
	
	set newname $USERDATA(name)

	regsub -all newname $body1 $newname new_body1
	regsub -all newname $body2 $newname new_body2

	eval "proc ${newname}_KinInit { $args1 } { $new_body1 }"
	eval "proc ${newname}_KinMove { $args2 } { $new_body2 }"
	 

	${newname}_KinInit $obj $eve $USERDATA(millisecond)
}

proc split_args { USERDATA args } {
        
        upvar $USERDATA myArray 
        set j 0
        foreach i   [split $args "&"]  {
                if { $j == 0 } {
                        set i [string trim $i "?"]
                }
                set k [split $i "="]
                set myArray([lindex $k 0]) [lindex $k 1] 
                incr j
        }
}

