if {"" == [info globals __kinema_tcl__]} {
set __kiname_tcl__ 0

proc KinMove { obj ev userdata } {
global newname0_KinCounter
global newname0 newname1 newname2
global vsContinue vsFileExit
global ending

    set ctrlobj $userdata

    set speed [vsGetVariable $ctrlobj speed]
    set skip [vsGetVariable $ctrlobj skip]
    set step [vsGetVariable $ctrlobj step]

    incr newname0_KinCounter
    vsKinGetFrame $obj cur max
    vsKinGetFrame $newname0 cur0 max0    
    vsKinGetFrame $newname1 cur1 max1
    vsKinGetFrame $newname2 cur2 max2

	if { $speed == $newname0_KinCounter } {

		set frame [expr ($cur + $step * $skip + 10 * $max) % $max] 
		if { $frame >= $max0 } { 
		set frame0 $max0
		} else { set frame0 $frame; }
		if { $frame >= $max1 } { 
		set frame1 $max1
		} else { set frame1 $frame; }
		if { $frame >= $max2 } { 
		set frame2 $max2
		} else { set frame2 $frame; }
		
	        vsKinSetFrame $newname0 $frame0
		vsKinSetFrame $newname1 $frame1
		vsKinSetFrame $newname2 $frame2
	
	set newname0_KinCounter 0
    }
	
   return $vsContinue

}


proc KinInit { obj ev userdata } {
global vsTclScript vsPeriodicTask newname0_KinCounter
global  newname0 newname1 newname2
global vsCSWorld vsAbsolute vsRelative
global ending Pos maxStep

    set millisecond $userdata
    set newname0 0
    set newname1 0
    set newname2 0
    vsKinNew "models/newname0.wrl" newname0
    vsKinNew "models/newname1.wrl" newname1
    vsKinNew "models/newname2.wrl" newname2


    set ending 0

   #vsTranslate $newname0 0 5 0 $vsCSWorld $vsRelative
   # vsTranslate $newname1 0 5 0 $vsCSWorld $vsRelative
   # vsTranslate $newname2 0 5 0 $vsCSWorld $vsRelative
    set newname0_KinCounter 0
    vsNewVariable $obj speed 1
    vsNewVariable $obj skip 1
    vsNewVariable $obj step 1


    set ctrlobj $obj
    source [vsWwwGetFile scripts/walking.tcl]
    vs_H_InitBuggy $newname0 0 0
    vs_H_InitBuggy $newname1 0 50
    vs_H_InitBuggy $newname2 0 100

vsAddTimeOutHandler $newname0 50 $vsTclScript "scripts/walking.tcl" vs_H_PeriodicMoveBuggy "data" $vsPeriodicTask
vsAddTimeOutHandler $newname1 50 $vsTclScript "scripts/walking.tcl" vs_H_PeriodicMoveBuggy "data" $vsPeriodicTask
vsAddTimeOutHandler $newname2 50 $vsTclScript "scripts/walking.tcl" vs_H_PeriodicMoveBuggy "data" $vsPeriodicTask

    vsAddTimeOutHandler $newname0 $millisecond $vsTclScript "" newname0_KinMove $obj $vsPeriodicTask
}
}
