if {"" == [info globals __kinema_tcl__]} {
set __kiname_tcl__ 0

proc KinMove { obj ev userdata } {
global newname0_KinCounter
global newname0 newname1 newname2
global vsContinue vsFileExit
global ending

    set ctrlobj $userdata

    set speed [vsGetVariable $ctrlobj speed]
    set skip [vsGetVariable $ctrlobj skip]
    set step [vsGetVariable $ctrlobj step]

    incr newname0_KinCounter
    vsKinGetFrame $obj cur max
    vsKinGetFrame $newname0 cur0 max0    
    vsKinGetFrame $newname1 cur1 max1
    vsKinGetFrame $newname2 cur2 max2

	if { $speed == $newname0_KinCounter } {

		set frame [expr ($cur + $step * $skip + 10 * $max) % $max] 
		if { $frame >= $max0 } { 
		set frame0 $max0
		} else { set frame0 $frame; }
		if { $frame >= $max1 } { 
		set frame1 $max1
		} else { set frame1 $frame; }
		if { $frame >= $max2 } { 
		set frame2 $max2
		} else { set frame2 $frame; }
		
	        vsKinSetFrame $newname0 $frame0
		vsKinSetFrame $newname1 $frame1
		vsKinSetFrame $newname2 $frame2
	
	set newname0_KinCounter 0
    }
    set return_value [alyConfigKinMove newname $obj $cur $max]
    return $return_value

}


proc KinInit { obj ev userdata } {
global vsTclScript vsPeriodicTask newname0_KinCounter
global  newname0 newname1 newname2
global vsCSWorld vsAbsolute vsRelative vsObjAttrName
global ending


      source [vsWwwGetFile ../world/kinconf.tcl]

    set millisecond $userdata
    set newname0 0
    set newname1 0
    set newname2 0
    vsKinNew "../world/newname0.wrl" newname0
    vsKinNew "../world/newname1.wrl" newname1
    vsKinNew "../world/newname2.wrl" newname2

    set ending 0

     vsTranslate $newname0 0 5 0 $vsCSWorld $vsRelative
    vsTranslate $newname1 0 5 0 $vsCSWorld $vsRelative
     vsTranslate $newname2 0 5 0 $vsCSWorld $vsRelative
    set newname0_KinCounter 0
    vsNewVariable $obj speed 1
    vsNewVariable $obj skip 1
    vsNewVariable $obj step 1

	# name is always bb_test so you just get bb from this
    set objname0 [split newname0 _]
    vsSetObjAttribute $newname0 $vsObjAttrName [lindex $objname0 0]
    set objname1 [split newname1 _]
    vsSetObjAttribute $newname1 $vsObjAttrName [lindex $objname1 0]
    set objname2 [split newname2 _]
    vsSetObjAttribute $newname2 $vsObjAttrName [lindex $objname2 0]

    set ctrlobj $obj
    source [vsWwwGetFile ../world/walking.tcl]
    alyInitInterpolator $newname0 0 0
    alyInitInterpolator $newname1 0 4
    alyInitInterpolator $newname2 0 7

    vsAddTimeOutHandler $newname0 $millisecond $vsTclScript "" newname0_KinMove $obj $vsPeriodicTask
}
}
