
proc libkinInit { obj eve userdata } {

	source [vsWwwGetFile "../lib/kinctrl2/kinema.tcl"]

 	split_args USERDATA $userdata 

	set args1 [info args KinInit ]
	set args2 [info args KinMove ]
	set body1 [info body KinInit ]
	set body2 [info body KinMove ]
	
	set newname0 $USERDATA(name0)
	set newname1 $USERDATA(name1)
	set newname2 $USERDATA(name2)

	regsub -all newname0 $body1 $newname0 new_body1
	regsub -all newname0 $body2 $newname0 new_body2

	regsub -all newname1 $new_body1 $newname1 nnw_body1
	regsub -all newname1 $new_body2 $newname1 nnw_body2

	regsub -all newname2 $nnw_body1 $newname2 nnn_body1
	regsub -all newname2 $nnw_body2 $newname2 nnn_body2

	eval "proc ${newname0}_KinInit { $args1 } { $nnn_body1 }"
	eval "proc ${newname0}_KinMove { $args2 } { $nnn_body2 }"
	 

	${newname0}_KinInit $obj $eve $USERDATA(millisecond)
}

proc split_args { USERDATA args } {
        
        upvar $USERDATA myArray 
        set j 0
        foreach i   [split $args "&"]  {
                if { $j == 0 } {
                        set i [string trim $i "?"]
                }
                set k [split $i "="]
                set myArray([lindex $k 0]) [lindex $k 1] 
                incr j
        }
}

