
proc alyConfigInterpolatorInit { obj eve userdata } {
global vsContinue vsCSWorld vsCSLocal vsAbsolute vsRelative 
global vsTclScript vsSporadicTask vsPeriodicTask
global vsObjAttrName



	
	if { $userdata== 0 } {
	set me [vsGetPerson]
        vsGetObjWRT $me x y z rx0 ry0 rz0 rx1 ry1 rz1 rx2 ry2 rz2
        vsNewVariable $me mat "$rx0 $ry0 $rz0 $rx1 $ry1 $rz1 $rx2 $ry2 $rz2 $x $y $z"
	vsNewVariable $me round 0
	vsNewVariable $me tround 0
	vsNewVariable $me avatar $obj
	vsWarning "Let's Cyber Blading!!"
	vsGetObjAttribute $obj $vsObjAttrName objname
	vsSetObjAttribute $me $vsObjAttrName $objname
	vsWarning "You are $objname!!"
	vsNewVariable $me speed 1
	vsNewVariable $me theend 0
	}
	vsNewVariable $obj speed 1

	if { $userdata != 0 } { # 0 means your avatar
		vsAddTimeOutHandler $obj 0 $vsTclScript "../lib/coll/coll.tcl" "coll_init" "data" $vsSporadicTask
		vsAddTimeOutHandler $obj 100 $vsTclScript "../lib/coll/coll.tcl" "coll_check" "data" $vsPeriodicTask
	} else {
		set me [vsGetPerson]
		vsNewVariable $me met 0

		#vsAddTimeOutHandler $me 0 $vsTclScript "../lib/cocpit/cocpit.tcl" "cocpit_init" $obj $vsSporadicTask
		vsAddTimeOutHandler $obj 0 $vsTclScript "../lib/soundctrl/soundctrl.tcl" "soundctrl_init" "data" $vsSporadicTask
       	}

}

proc alyInitInterpolator { obj eve userdata } {
global vsContinue vsCSWorld vsCSLocal vsAbsolute vsRelative 
global vsTclScript vsPeriodicTask
global Pos


	alyConfigInterpolatorInit $obj $eve $userdata
	if { $userdata == 0 } {
	source [vsWwwGetFile ../world/data.tcl]
	}

	set interp_count $userdata
	set max 20
	vsNewVariable $obj max $max
	vsNewVariable $obj interp_count [expr $interp_count%$max]
	vsNewVariable $obj step 0


	if { $userdata == 0 } {
 vsAddTimeOutHandler $obj 300 $vsTclScript "" \
 "alyDoInterpolator" "me" $vsPeriodicTask
	} else {
 vsAddTimeOutHandler $obj 300 $vsTclScript "" \
 "alyDoInterpolator" "data" $vsPeriodicTask
	}
}
set maxStep 35.0
proc alyDoInterpolator { obj eve userdata } {
global vsContinue vsCSWorld vsCSLocal vsCSParent vsAbsolute vsRelative 
global maxStep Pos
global vsObjAttrName

	set Step [ vsGetVariable $obj step ]
	set Step [expr $Step*1.0]
	set interp_count [ vsGetVariable $obj interp_count ]
	set max [ vsGetVariable $obj max ]
	set me [vsGetPerson]

	if { ![string compare me $userdata] } {
	set speed [vsGetVariable $me speed]
	} else {
	set speed [vsGetVariable $obj speed]
	}
	
	if { $speed > 0 } {
	set last [expr ($interp_count - 1)%$max ]
	} else {
	set last [expr ($interp_count + 1)%$max ]
	}


	set lx $Pos($last,x)
	set ly $Pos($last,y)
	set lz $Pos($last,z)
	set langx [expr $Pos($last,angx) - $Pos(0,angx) ]
	set langy [expr $Pos($last,angy) - $Pos(0,angy) ]
	set langz [expr $Pos($last,angz) - $Pos(0,angz) ]

	set cx $Pos($interp_count,x)
	set cy $Pos($interp_count,y)
	set cz $Pos($interp_count,z)
	set cangx [expr $Pos($interp_count,angx) - $Pos(0,angx) ]
	set cangy [expr $Pos($interp_count,angy) - $Pos(0,angy) ]
	set cangz [expr $Pos($interp_count,angz) - $Pos(0,angz) ]

	set ss [expr $maxStep - $Step]
	set x [expr [expr $lx * $ss + $cx * $Step] / $maxStep ]
	set y [expr [expr $ly * $ss + $cy * $Step] / $maxStep ]
	set z [expr [expr $lz * $ss + $cz * $Step] / $maxStep ]


	# Move and Rotate
	

    if { ![string compare $userdata me] } {
	vsTranslate $obj $x $y $z $vsCSWorld $vsAbsolute
	set ss [expr $maxStep - $Step]
	set ax [expr ( $langx * $ss + $cangx * $Step ) / $maxStep ]
	set ay [expr ( $langy * $ss + $cangy * $Step ) / $maxStep ]
	set az [expr ( $langz * $ss + $cangz * $Step ) / $maxStep ]
	set aax [expr $ax+180]
	if { [vsGetVariable $me speed ] < 0 } {
		set ay [expr $ay+180]
	}	
	vsRotateAngle $obj $aax $ay $az $vsCSLocal $vsAbsolute
    } else {
	vsTranslate $obj $x $y $z $vsCSWorld $vsAbsolute
	vsTranslate $obj 1 0 0 $vsCSLocal $vsRelative
	set angx [expr (-$langx+$cangx)/$maxStep ]
	set angy [expr (-$langy+$cangy)/$maxStep ]
	set angz [expr (-$langz+$cangz)/$maxStep ]
	vsRotateAngle $obj $angx $angy $angz $vsCSLocal $vsRelative
    }

	#set userdata 0
	set first [vsGetVariable $me first]

	if { $first == -1 } {
	if { ![string compare $userdata me] } {
	 	set camera [ vsGetPerson ]
		set aay [expr $ay+180]
		vsRotateAngle $camera $ax $aay $az $vsCSLocal $vsAbsolute
		#vsRotateAngle $camera $ax $aay $az $vsCSWorld $vsAbsolute

		vsGetObjWRT $obj xa ya za rx0 ry0 rz0 rx1 ry1 rz1 rx2 ry2 rz2	
		set xx 0
		set yy 0
		set zz -1

		set xxx [expr $xx*$rx0 + $yy*$ry0 + $zz*$rz0 ]
		set yyy [expr $xx*$rx1 + $yy*$ry1 + $zz*$rz1 ]
		set zzz [expr $xx*$rx2 + $yy*$ry2 + $zz*$rz2 ]

	 	set camx [expr $xa + $xxx*3.0 ]
	 	set camy [expr $ya +1]
	 	set camz [expr $za + $zzz*3.0 ]
	 	vsTranslate $camera $camx $camy $camz $vsCSWorld $vsAbsolute

	}
	}

	# increase interp_count  
	set abspeed [expr abs($speed)]
	set Step [expr $Step + $abspeed]

	if { $Step >= $maxStep } {
	if { $speed > 0 } {
	set interp_count [expr ($interp_count + 1)%$max ]
	} else {
	set interp_count [expr ($interp_count - 1)%$max ]
	}
	set Step 0
	}

	#set theend [vsGetVariable $me theend]
	#if { $theend == 1} {
	#	return $vsStop
	#}

	if { ![string compare $userdata me] } {
	#	set tround [vsGetVariable $me tround]
		#if { $interp_count == 12  } {
	#	if { $Step == 0 } {
	#	if { $tround == 2 } {
		#	set miti [vsGetVariable $me miti]
			#vsRotateAngle $miti 0 0 20 $vsCSParent $vsRelative
	#		vsTranslate $me -21 7 0.6 $vsCSWorld $vsRelative
	#		vsRotateAngle $me 0 60 0 $vsCSLocal $vsAbsolute
	#		vsSetVariable $me first 0
	#		#vsWwwOpenFile [vsWwwGetFile ../ending/ending.wrl]
	#		vsSetVariable $me theend 1
	#		return $vsStop
	#	}
	#	}
	#	}
	if { $speed > 0 } {
	if { $interp_count == 0 && $Step == 0} {
		# incr
		set round [expr ([vsGetVariable $me round]+1)%3 ]
	set Round [expr $round+1]
	vsWarning "------------ $Round round ---------------"
	if { $Round == 1 } {
		if { $speed > 0 } {
		if { $speed > $Round } {
			vsWarning "Speed down, down, down....."
		}
		vsSetVariable $me speed $Round
		} else {
		}
	} elseif { $Round == 2 } {
		if { $speed > 0 } {
		if { $speed > $Round } {
			vsWarning "Speed down, down, down....."
		}
		vsSetVariable $me speed $Round
		} else {
		}
	} elseif { $Round == 3 } {

		set tround [vsGetVariable $me tround]
		vsSetVariable $me tround [expr $tround + 1]

		if { $speed > 0 } {
		if { $speed > $Round } {
			vsWarning "Speed down, down, down....."
		}
		vsSetVariable $me speed $Round
		vsWarning "It is a Jump time!!!"
		} else {
		}
	}
	vsSetVariable $me round  $round
	}
	} else {
		vsSetVariable $me round 0
	}
	}

	vsSetVariable $obj interp_count $interp_count
	set Step [expr $Step*1.0]
	vsSetVariable $obj step $Step
	return $vsContinue
}
